import java.io.*;
public class Network
{
    public int MaxNeurons = 20;
    public int MaxWires = MaxNeurons*MaxNeurons;
    
    public int nNeurons = 0;
    public int nWires = 0;
    
    public Neuron [] Neurons;
    public Connection [] Wires;
      
    
    public void Network()
    {
        this.nNeurons = 0;
        this.nWires = 0;
        this.Neurons = new Neuron[MaxNeurons];
       // System.out.println(Neurons.toString());
        this.Wires = new Connection[MaxWires];
    }
    
    public void EraseNetwork()
    {   
        this.Network();
        nNeurons = 0;
        nWires = 0;
    }
    
    public void AddNeuron(Neuron n)
    {
        if (nNeurons < MaxNeurons - 1)
        {
            nNeurons++;
            if (Neurons == null)
            {
                Neurons = new Neuron[MaxNeurons];
            }
            Neurons[nNeurons - 1] = n;      
            n.waveDisplay.SetNeuronNumber(nNeurons-1);
        }
    }
    
    public void AddWire(Connection c)
    {
        if (nWires < MaxWires - 1)
        {
            nWires++;
            if (Wires == null)
            {
                Wires = new Connection[MaxWires];
            }
            Wires[nWires-1] = c;
        }
    }
    
    public void SaveToFile(String path)
    {
        //String fileName = this.saveNetworkDialog.FileName;
        try
        {
	FileWriter sr = new FileWriter(new File(path));
//	while ( myEnumerator.MoveNext() )
		for (int i=0; i<nNeurons; i++)
		{
			if (Neurons[i]!= null)
			{
				Neuron neuron = Neurons[i];
				sr.write("n:d=\"");
                           
                                String tmpStr="";
                                
				if (neuron instanceof DiffNeuron) 
				{				
					sr.write("D:prevInput="+((DiffNeuron)neuron).previousValue+",");
				}
				else if (neuron instanceof ConstNeuron)
				{
					sr.write("*:const=1,");
				} 
				else if (neuron instanceof RndNeuron)
				{
					sr.write("Rnd:");
				}
				else if (neuron instanceof SigmoidNeuron)
				{
					sr.write("N:sigmo="+((SigmoidNeuron)neuron).sigmo+
                                                ",force="+((SigmoidNeuron)neuron).force+
                                                ",inertia="+((SigmoidNeuron)neuron).inertia+",");
						
				}
				else if  (neuron instanceof SigmoidUnipolarNeuron)
				{
					sr.write("N:sigmo="+((SigmoidUnipolarNeuron)neuron).sigmo+
                                                ",force="+((SigmoidUnipolarNeuron)neuron).force+
                                                ",inertia="+((SigmoidUnipolarNeuron)neuron).inertia+",");
				}
				else if (neuron instanceof SinNeuron)
				{
					sr.write("Sin:f="+((SinNeuron)neuron).f0+",t="+((SinNeuron)neuron).t+",");
						
				}
				else if (neuron instanceof ThresholdNeuron) 
				{
					sr.write("Thr:hi="+((ThresholdNeuron)neuron).GetHigh()+
                                        ",lo="+((ThresholdNeuron)neuron).GetLow()+
                                        ",t="+((ThresholdNeuron)neuron).GetThreshold()+",");
				}
				sr.write("x="+((Neuron)neuron).x+",y="+((Neuron)neuron).y+"\"\n");
			}// end if
             }  // end for nNeurons
                for (int i=0; i<nWires; i++)
                {                    
                    sr.write("c:"+Wires[i].to+", "+Wires[i].from+", "+Wires[i].weight+"\n");				
		}      
          sr.close();
        }
        catch(IOException e)
        {
          System.out.println(e);
        }
        

    }
    
    public void ReadFromFile(String path)
    {
     try
      {
        FileReader fr = new FileReader(path);
        BufferedReader sr = new BufferedReader(fr);
        String input;
        Neuron neuron = new ConstNeuron(1);
        //#########################   			
        this.EraseNetwork();
        try
        {
	while ((input=sr.readLine())!=null) 
	{
            if (input.startsWith("n")) // reading neuron
            {
		int n=1;
		while (n < input.length())
		{	
                	if (input.startsWith("d",n)) // neuron description
			{
                        	n+=3; // skip ="
				String sNeuronType = "";
				while (!input.startsWith(":",n)) // get Neuron type
				{
                                	sNeuronType+= input.charAt(n);
					n++;
				}
				//Hashtable paramTable = new Hashtable();
                                if (sNeuronType.equals("N"))
                                {
                                    double sigmo=0;
                                    double force=0;
                                    double inertia=0;
                                    int x=0;
                                    int y=0;
                                    while (!input.startsWith("\"",n)) // to the end of neuron parameters
                                    {
                                        n++;
                                        String sParamName = "";
                                        while (!input.startsWith("=",n)) // to the end of neuron paramtere name
                                        {
                                            sParamName+=input.charAt(n);
                                            n++;
                                        }
                                        n++;
                                        String sParamValue = "";
                                        while ((!input.startsWith(",",n)) && (!input.startsWith("\"",n))) // to the end of neuron parameter value
                                        {
                                            sParamValue+=input.charAt(n);
                                            n++;
                                        }
                                        
                                        if (sParamName.equals("sigmo"))
                                        {
                                            sigmo = Double.parseDouble(sParamValue);
                                        }
                                        else if (sParamName.equals("force"))
                                        {
                                            force = Double.parseDouble(sParamValue);
                                        }
                                        else if (sParamName.equals("inertia"))
                                        {
                                            inertia = Double.parseDouble(sParamValue);
                                        }
                                        else if (sParamName.equals("x"))
                                        {
                                            x = Integer.parseInt(sParamValue);
                                        }
                                        else if (sParamName.equals("y"))
                                        {
                                            y = Integer.parseInt(sParamValue);
                                        }                                        
                                    }
                                    neuron = new SigmoidNeuron(sigmo,force,inertia);
                                    neuron.SetX(x);
                                    neuron.SetY(y);
                                }
                                else if (sNeuronType.equals("Nu"))
                                {                                  
                                    double sigmo=0;
                                    double force=0;
                                    double inertia=0;
                                    int x=0;
                                    int y=0;
                                    while (!input.startsWith("\"",n)) // to the end of neuron parameters
                                    {
                                        n++;
                                        String sParamName = "";
                                        while (!input.startsWith("=",n)) // to the end of neuron paramtere name
                                        {
                                            sParamName+=input.charAt(n);
                                            n++;
                                        }
                                        n++;
                                        String sParamValue = "";
                                        while ((!input.startsWith(",",n)) && (!input.startsWith("\"",n))) // to the end of neuron parameter value
                                        {
                                            sParamValue+=input.charAt(n);
                                            n++;
                                        }
                                        
                                        if (sParamName.equals("sigmo"))
                                        {
                                            sigmo = Double.parseDouble(sParamValue);
                                        }
                                        else if (sParamName.equals("force"))
                                        {
                                            force = Double.parseDouble(sParamValue);
                                        }
                                        else if (sParamName.equals("inertia"))
                                        {
                                            inertia = Double.parseDouble(sParamValue);
                                        }
                                        else if (sParamName.equals("x"))
                                        {
                                            x = Integer.parseInt(sParamValue);
                                        }
                                        else if (sParamName.equals("y"))
                                        {
                                            y = Integer.parseInt(sParamValue);
                                        }                                        
                                    }
                                    neuron = new SigmoidUnipolarNeuron(sigmo,force,inertia);
                                    neuron.SetX(x);
                                    neuron.SetY(y);   
                                }
                                else if (sNeuronType.equals("*"))
                                {
                                    double con=0;
                                    int x=0;
                                    int y=0;
                                    while (!input.startsWith("\"",n)) // to the end of neuron parameters
                                    {
                                        n++;
                                        String sParamName = "";
                                        while (!input.startsWith("=",n)) // to the end of neuron paramtere name
                                        {
                                            sParamName+=input.charAt(n);
                                            n++;
                                        }
                                        n++;
                                        String sParamValue = "";
                                        while ((!input.startsWith(",",n)) && (!input.startsWith("\"",n))) // to the end of neuron parameter value
                                        {
                                            sParamValue+=input.charAt(n);
                                            n++;
                                        }
                                        if (sParamName.equals("const"))
                                        {
                                            con = Double.parseDouble(sParamValue);
                                        }
                                        else if (sParamName.equals("x"))
                                        {
                                            x = Integer.parseInt(sParamValue);
                                        }
                                        else if (sParamName.equals("y"))
                                        {
                                            y = Integer.parseInt(sParamValue);
                                        }                                        
                                    }
                                    neuron = new ConstNeuron(con);
                                    neuron.SetX(x);
                                    neuron.SetY(y);
                                }
                                else if (sNeuronType.equals("D"))
                                {
                                    double con=0;
                                    int x=0;
                                    int y=0;
                                    while (!input.startsWith("\"",n)) // to the end of neuron parameters
                                    {
                                        n++;
                                        String sParamName = "";
                                        while (!input.startsWith("=",n)) // to the end of neuron paramtere name
                                        {
                                            sParamName+=input.charAt(n);
                                            n++;
                                        }
                                        n++;
                                        String sParamValue = "";
                                        while ((!input.startsWith(",",n)) && (!input.startsWith("\"",n))) // to the end of neuron parameter value
                                        {
                                            sParamValue+=input.charAt(n);
                                            n++;
                                        }
                                        if (sParamName.equals("prevInput"))
                                        {
                                            con = Double.parseDouble(sParamValue);
                                        }
                                        else if (sParamName.equals("x"))
                                        {
                                            x = Integer.parseInt(sParamValue);
                                        }
                                        else if (sParamName.equals("y"))
                                        {
                                            y = Integer.parseInt(sParamValue);
                                        }                                        
                                    }
                                    neuron = new DiffNeuron(con);
                                    neuron.SetX(x);
                                    neuron.SetY(y);
                                }
                                else if (sNeuronType.equals("Thr"))
                                {
                                    double hi=0;
                                    double lo=0;
                                    double t=0;
                                    
                                    int x=0;
                                    int y=0;
                                    while (!input.startsWith("\"",n)) // to the end of neuron parameters
                                    {
                                        n++;
                                        String sParamName = "";
                                        while (!input.startsWith("=",n)) // to the end of neuron paramtere name
                                        {
                                            sParamName+=input.charAt(n);
                                            n++;
                                        }
                                        n++;
                                        String sParamValue = "";
                                        while ((!input.startsWith(",",n)) && (!input.startsWith("\"",n))) // to the end of neuron parameter value
                                        {
                                            sParamValue+=input.charAt(n);
                                            n++;
                                        }
                                        if (sParamName.equals("hi"))
                                        {
                                            hi = Double.parseDouble(sParamValue);
                                        }
                                        else if (sParamName.equals("lo"))
                                        {
                                            lo = Double.parseDouble(sParamValue);
                                        }
                                        else if (sParamName.equals("t"))
                                        {
                                            t = Double.parseDouble(sParamValue);
                                        }                                        
                                        else if (sParamName.equals("x"))
                                        {
                                            x = Integer.parseInt(sParamValue);
                                        }
                                        else if (sParamName.equals("y"))
                                        {
                                            y = Integer.parseInt(sParamValue);
                                        }                                        
                                    }
                                    neuron = new ThresholdNeuron(hi,lo,t);
                                    neuron.SetX(x);
                                    neuron.SetY(y);
                                }
                                else if (sNeuronType.equals("Rnd"))
                                {
                                    int x=0;
                                    int y=0;
                                    while (!input.startsWith("\"",n)) // to the end of neuron parameters
                                    {
                                        n++;
                                        String sParamName = "";
                                        while (!input.startsWith("=",n)) // to the end of neuron paramtere name
                                        {
                                            sParamName+=input.charAt(n);
                                            n++;
                                        }
                                        n++;
                                        String sParamValue = "";
                                        while ((!input.startsWith(",",n)) && (!input.startsWith("\"",n))) // to the end of neuron parameter value
                                        {
                                            sParamValue+=input.charAt(n);
                                            n++;
                                        }
                                 
                                        if (sParamName.equals("x"))
                                        {
                                            x = Integer.parseInt(sParamValue);
                                        }
                                        else if (sParamName.equals("y"))
                                        {
                                            y = Integer.parseInt(sParamValue);
                                        }                                        
                                    }
                                    neuron = new RndNeuron();
                                    neuron.SetX(x);
                                    neuron.SetY(y);
                                }
                                else if (sNeuronType.equals("Sin"))
                                {
                                    double f=0;
                                    double t=0;
                                    
                                    int x=0;
                                    int y=0;
                                    while (!input.startsWith("\"",n)) // to the end of neuron parameters
                                    {
                                        n++;
                                        String sParamName = "";
                                        while (!input.startsWith("=",n)) // to the end of neuron paramtere name
                                        {
                                            sParamName+=input.charAt(n);
                                            n++;
                                        }
                                        n++;
                                        String sParamValue = "";
                                        while ((!input.startsWith(",",n)) && (!input.startsWith("\"",n))) // to the end of neuron parameter value
                                        {
                                            sParamValue+=input.charAt(n);
                                            n++;
                                        }
                                        if (sParamName.equals("f"))
                                        {
                                            f = Double.parseDouble(sParamValue);
                                        }
                                        else if (sParamName.equals("t"))
                                        {
                                            t = Double.parseDouble(sParamValue);
                                        }                                        
                                        else if (sParamName.equals("x"))
                                        {
                                            x = Integer.parseInt(sParamValue);
                                        }
                                        else if (sParamName.equals("y"))
                                        {
                                            y = Integer.parseInt(sParamValue);
                                        }                                        
                                    }
                                    neuron = new SinNeuron(f,t);
                                    neuron.SetX(x);
                                    neuron.SetY(y);
                                }
			}
			n++;
		}
                this.AddNeuron(neuron);
	}
	else if (input.startsWith("c",0)) //reading connection
	{
            int k=2;
            String sTo = "";
            while (!input.startsWith(",",k)) // connection TO
            {
		sTo += input.charAt(k);
		k++;
            }
            k=k+2; // skip ", "
            String sFrom = "";
            while (!input.startsWith(",",k))
            {
		sFrom += input.charAt(k);
		k++;
            }
            k = k+2;
            String sWeight = "";
            while (k < input.length())
            {
            	sWeight += input.charAt(k);
		k++;
            }
            int from = Integer.parseInt(sFrom);
            int dest = Integer.parseInt(sTo);
            double w = Double.parseDouble(sWeight);
            Connection conn = new Connection();
            conn.weight = w;
            conn.from = from;
            conn.to = dest;
            this.AddWire(conn);
            //((Neuron)neurons[dest]).weights.Add(from,new Weight(Convert.ToDouble(sWeight,new CultureInfo("en-GB")),true));
	} 
	else
	{
          //  MessageBox.Show("Error reading file!");
	}
    }}
        catch(IOException e)
        {
            System.out.println(e);
        }
        try
        {
            sr.close();   
        }
        catch(IOException e)
        {
            System.out.println(e);
        }
        
        
     }
     catch(FileNotFoundException e)
     {
         System.out.println(e);
     }
    
   //#########################
}
    
    public void ShowWaveforms()
    {
        this.UpdateInputsFromWires();
        for (int i=0; i<this.nNeurons; i++)
        {// System.out.println(Neurons[0].waveDisplay.toString());
            double d = Neurons[i].Evaluate();
            //d = Neurons[1].Evaluate();
            //d = Neurons[2].Evaluate();
           Neurons[i].waveDisplay.ShowWindow();
        }
    }
    public void KillWaveforms()
    {
        //this.UpdateInputsFromWires();
        for (int i=0; i<this.nNeurons; i++)
        {// System.out.println(Neurons[0].waveDisplay.toString());
          //  double d = Neurons[i].Evaluate();
            //d = Neurons[1].Evaluate();
            //d = Neurons[2].Evaluate();
           Neurons[i].waveDisplay.setVisible(false);
        }
    }
    
    public void deleteNeuron(int num)
    {
        System.out.println("delete neuron "+num);
        
        boolean noMoreWires = false;
        while (noMoreWires == false)
        {
            if (nWires == 0)
            {
                noMoreWires = true;
                break;
            }
            for (int i=0; i<nWires; i++)
            {
                noMoreWires = true;
                if ((Wires[i].from == num)||(Wires[i].to == num))
                {
                    deleteConnection(i);
                    noMoreWires = false;
                    break;
                }
            }
        }
        Neurons[num] = Neurons[nNeurons - 1];
        for (int i=0; i<nWires; i++)
        {
          if (Wires[i].from == nNeurons - 1)
            {
                Wires[i].from = num;
            }
        }
        for (int i=0; i<nWires; i++)
        {
          if (Wires[i].to == nNeurons - 1)
            {
                Wires[i].to = num;
            }
        }
        nNeurons--;
        this.KillWaveforms();
        this.UpdateInputsFromWires();
    }
    
    public void deleteConnection(int num)
    {
        System.out.println("delete connection "+num);
        Wires[num] = Wires[nWires - 1];
        nWires--;
    }
    
    public void UpdateInputsFromWires()
    {     
        int from,to;
        double w;
        double d;
        for (int i=0; i<this.nNeurons; i++)
        {
            this.Neurons[i].Inputs = new Input[Wires.length];
            this.Neurons[i].nInputs = nNeurons;
            for(int j=0; j<this.nNeurons; j++)
            {
                this.Neurons[i].Inputs[j] = new Input();
                this.Neurons[i].Inputs[j].Weight = 0.0;  
            }  
        }        
        for (int i=0; i<this.nWires; i++)
        {
            //tu trzeba policzyc liczbe wejsc dla kazdego neuronu.
            from = Wires[i].from;
            to = Wires[i].to;
            w = Wires[i].weight;
            this.Neurons[to].Inputs[from].Weight = w;           
            d = this.Neurons[from].Output;
            this.Neurons[to].Inputs[from].SetSignal(d);
        }
    }   
    public void TakeStep(boolean visible)
    {
      //  System.out.println("Step");
        for (int i=0; i<this.nWires; i++)
        {
            //tu trzeba policzyc liczbe wejsc dla kazdego neuronu.
            int from = Wires[i].from;
            int to = Wires[i].to;
            double w = Wires[i].weight;
            //this.Neurons[to].Inputs[from].SetSignal();           
            double d = this.Neurons[from].Output;
            this.Neurons[to].Inputs[from].SetSignal(d);
        }
        for (int i=0; i<this.nNeurons; i++)
        {
            Neurons[i].Evaluate();
            Neurons[i].waveDisplay.SetNextSample(Neurons[i].Output, visible);
        }
    }
    
    public double Mse = 0;
    
    public void TakeSteps(int n, boolean visible)
    {
        System.out.print("steps = ");
        System.out.println(n);
        
        for (int i=0; i<this.nNeurons; i++)
        {
            Neurons[i].waveDisplay.ResetCurrentSample(visible);
        }      
        for(int i=0; i<n; i++)
        {
            TakeStep(visible);
        }
        this.Mse = 0;
        for (int i=0; i<this.nNeurons; i++)
        {
            this.Mse += this.Neurons[i].waveDisplay.MeanSquareError();
        }       
    }
    
    
    public void AddRandom(boolean neurons, boolean connections)
    {
        if (neurons)
        {
            for (int i=0; i<this.nNeurons; i++)
            {
                if (Neurons[i].getOptimize())
                {
                    Neurons[i].AddRandom();
                }
            }
        }
        if (connections)
        {
            for (int i=0; i<this.nWires; i++)
            {
                if (Wires[i].getOptimize())
                {
                    Wires[i].AddRandom();
                }
            }
        }
    }
    
    
    
    public Network CloneNetwork(Network klon)
    {
        //Network klon = new Network();
        
        //klon.nNeurons = this.nNeurons;
        //klon.nWires = this.nWires;
        //klon.Mse = this.Mse;
        
        //klon.Neurons[0] = new ConstNeuron(2);
        
        //if (klon.Neurons == null)
        //{
            klon.Neurons = new Neuron[klon.MaxNeurons];
            klon.nNeurons = 0;
        //}
        //if (klon.Wires == null)
        //{
            klon.Wires = new Connection[klon.MaxWires];
        //}
        klon.nWires = 0;
        
        
        for (int i=0; i<this.nNeurons; i++)
        {
            if (this.Neurons[i] instanceof ConstNeuron)
            {
                klon.AddNeuron(new ConstNeuron(((ConstNeuron)this.Neurons[i]).GetValue(), this.Neurons[i].waveDisplay));
                klon.Neurons[i].setOptimize(this.Neurons[i].getOptimize());
            }
            else
            if (this.Neurons[i] instanceof DiffNeuron)
            {
                klon.AddNeuron( new DiffNeuron(((DiffNeuron)this.Neurons[i]).previousValue, this.Neurons[i].waveDisplay));
            }
            else
            if (this.Neurons[i] instanceof RndNeuron)
            {
                klon.AddNeuron(new RndNeuron(this.Neurons[i].waveDisplay));
            }
            else
            if (this.Neurons[i] instanceof SigmoidNeuron)
            {
                klon.AddNeuron(new SigmoidNeuron(((SigmoidNeuron)this.Neurons[i]).sigmo,
                                                       ((SigmoidNeuron)this.Neurons[i]).force,
                                                        ((SigmoidNeuron)this.Neurons[i]).inertia, 
                                                        this.Neurons[i].waveDisplay));
                 klon.Neurons[i].setOptimize(this.Neurons[i].getOptimize());
            }
            else
            if (this.Neurons[i] instanceof SigmoidUnipolarNeuron)
            {
                klon.AddNeuron( new SigmoidUnipolarNeuron(((SigmoidUnipolarNeuron)this.Neurons[i]).sigmo,
                                                       ((SigmoidUnipolarNeuron)this.Neurons[i]).force,
                                                        ((SigmoidUnipolarNeuron)this.Neurons[i]).inertia,
                                                        this.Neurons[i].waveDisplay));
                 klon.Neurons[i].setOptimize(this.Neurons[i].getOptimize());
            }
            else
            if (this.Neurons[i] instanceof SinNeuron)
            {
                klon.AddNeuron(new SinNeuron(((SinNeuron)this.Neurons[i]).f0,
                                                       ((SinNeuron)this.Neurons[i]).t,
                                                       this.Neurons[i].waveDisplay));
                 klon.Neurons[i].setOptimize(this.Neurons[i].getOptimize());
            }
            else
            if (this.Neurons[i] instanceof ThresholdNeuron)
            {
                klon.AddNeuron(new ThresholdNeuron(((ThresholdNeuron)this.Neurons[i]).GetHigh(),
                                                       ((ThresholdNeuron)this.Neurons[i]).GetLow(),
                                                        ((ThresholdNeuron)this.Neurons[i]).GetThreshold(),
                                                        this.Neurons[i].waveDisplay));
                klon.Neurons[i].setOptimize(this.Neurons[i].getOptimize());
            }
            if (this.Neurons[i] instanceof Neuron)
            {
                klon.Neurons[i].SetX(this.Neurons[i].GetX());
                klon.Neurons[i].SetY(this.Neurons[i].GetY());
            }
        }
        for (int i=0; i<this.nWires; i++)
        {
            Connection c = new Connection();
            c.from = ((Connection)Wires[i]).from;
            c.to = ((Connection)Wires[i]).to;
            c.weight = ((Connection)Wires[i]).weight;
            c.setOptimize(Wires[i].getOptimize());
            klon.AddWire(c);
        }
        return klon;
    }
}
