/*
 * Polynominal.java
 *
 * Created on 16 lipiec 2001, 17:07
 */

/**
 *
 * @author  k
 */

public class Polynominal {
    
    private int order = 1;
    
    private double[] coeffs;
    public MhPoint[] points;
    
    private boolean lagrange;
    
    public boolean isLagrange()
    {
        return lagrange;
    }
    
    /** Creates a new instance of Polynominal */
    public Polynominal(double[] Coeffs) { // todo: if an empty array is passed then raise the exception !
        lagrange = false;
        order = Coeffs.length-1;
        coeffs = new double[order+1];
        for(int i=0; i<coeffs.length; i++){//todo: ? is locking necessary ?
            coeffs[i] = Coeffs[i];
        }
    }
    public Polynominal(MhPoint[] MhPoints){ // Lagrange Interpolation
        lagrange = true;
        order = MhPoints.length-1;
        //coeffs = new double[order+1];
        points = new MhPoint[order+1];
        for(int i=0; i<MhPoints.length; i++){//todo: ? is locking necessary ?
            points[i] = new MhPoint();
            points[i].SetXY(MhPoints[i].GetX(),MhPoints[i].GetY());
        }
    }
    public Polynominal(Polynominal p) //niedokonczone!
    {
        if (p.lagrange) {
            this.lagrange = true;
            order = p.points.length-1;
            //coeffs = new double[order+1];
            points = new MhPoint[order+1];
            for(int i = 0; i < p.points.length; i++) 
            {//todo: ? is locking necessary ?
                this.points[i] = new MhPoint();
                this.points[i].SetXY(p.points[i].GetX(), p.points[i].GetY());
            }
        }
        else 
        {
            this.lagrange = false;
            order = p.coeffs.length-1;
            this.coeffs = new double[order+1];
            for(int i = 0; i < p.coeffs.length; i++)
            {//todo: ? is locking necessary ?
                this.coeffs[i] = p.coeffs[i];
            }
        }
    }
    
    public double Evaluate(double X) {
        if (!lagrange){ // schemat Hornera
            double v=0;
            // todo: check if there are any coefficients !
            for(int i=order; i>=1; i--){
                v = (v + coeffs[i])*X;
            }
            v = v + coeffs[0];
            return v;
        } else { // wzor interpolacyjny Lagrange'a
            double v=0;
            for (int i=0; i<=order; i++){
                double p=1;
                for (int k=0; k<=order; k++){
                    if (k!=i){
                        p=p*(X-points[k].GetX())/(points[i].GetX()-points[k].GetX());
                    }
                }
                v=v+points[i].GetY()*p;
            }
            return v;
        }
    }
}
